'From Squeak2.8alpha of 9 March 2000 [latest update: #1919] on 19 March 2000 at 5:38:28 pm'!
Error subclass: #LindaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk'!
Object subclass: #LindaTalkBlocking
	instanceVariableNames: 'tuple bed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk'!
LindaTalkBlocking class
	instanceVariableNames: ''!
Process subclass: #LindaTalkProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk'!
LindaTalkProcess class
	instanceVariableNames: ''!
Object subclass: #Subspace
	instanceVariableNames: 'mutex tuplesIn tuplesOut tuplesRd tuplesEval mixer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk'!
Subspace class
	instanceVariableNames: ''!
Object subclass: #Tuple
	instanceVariableNames: 'fields '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk'!
Tuple class
	instanceVariableNames: ''!
Object subclass: #TupleField
	instanceVariableNames: 'type value name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk'!
TupleField class
	instanceVariableNames: ''!
Object subclass: #TupleSpace
	instanceVariableNames: 'subspaces '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk'!
TupleSpace class
	instanceVariableNames: ''!

!Object methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 21:28'!
asTuple
"----------------------------------------------------
     Project:    Linda
    Author:      Marcio Q. Marchini
    Modified: 30/11/93

    Creates a tuple from  a given object
----------------------------------------------------
"

  ^ Tuple new add: self; yourself! !

!Object methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 13:16'!
| anObject
"
----------------------------------------------------
     Project:    Linda
    Author:      Marcio Q. Marchini
    Modified: 30/11/93

    Creates a tuple with two objects: self and anObject
----------------------------------------------------
"

  ^ Tuple new add: self; add: anObject; yourself! !


!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:03'!
forkLindaTalk
	"Creates a named LindaTalk process"

	^ self forkLindaTalkNamed:  'LindaTalk Process'! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:03'!
forkLindaTalkAt: priority 
	"Creates a named LindaTalk process with a given priority"

	^ self  forkLindaTalkAt:  priority  named: 'LindaTalk Process'! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:04'!
forkLindaTalkAt: priority named: aName
	"Creates a named LindaTalk process with a given priority and name"

	| forkedProcess |                               

	forkedProcess _ self newLindaTalkProcess.
	forkedProcess priority: priority.
	forkedProcess resume. " name: aName "
	^forkedProcess! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:05'!
forkLindaTalkNamed: aName
	"Creates a named LindaTalk process"

	| forkedProcess |
	forkedProcess _ self newLindaTalkProcess.
	forkedProcess resume. " name: aName ; "
	^forkedProcess! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:06'!
newLindaTalkProcess
	"Actually creates a named LindaTalk process"
	^LindaTalkProcess 
		forContext: 
			[self value.
			Processor terminateActive]
		priority: Processor activePriority! !


!Collection methodsFor: 'as yet unclassified'!
asTuple
"----------------------------------------------------
     Project:    Linda
    Author:      Marcio Q. Marchini
    Modified: 30/11/93

    Creates a tuple from a collection of objects
----------------------------------------------------
"

  ^ Tuple new addAll: self; yourself! !


!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:27'!
initBed
	"Initializes the Semaphore used to synchronize
	the waiting processes" 
 
	bed := self class newBed! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:07'!
initTuple: aTuple
	tuple := aTuple! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:28'!
nilBed 
	"Makes nil  the Semaphore used to synchronize
	the waiting processes" 

	bed := nil! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:29'!
sleepProcess 
	"Blocks the current process until
	a match happens. 
	Probably a rd or in." 
	self initBed.
	bed wait. 
	self nilBed! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:29'!
tuple 
	"Returns the tuple which caused the blocking"
	^ tuple ! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:29'!
wakeUpProcess 
	"Wakes up the process that was waiting for the tuple. 
	Probably a rd or in."
	bed signal! !


!LindaTalkBlocking class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:30'!
forTuple: aTuple
	"Creates a new LindaTalkBlocking for the given tuple"
	^ self new initTuple: aTuple;
		initBed;
		yourself! !

!LindaTalkBlocking class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:31'!
newBed
	"Returns a new bed for the processes to sleep (a Semaphore)"
	^ Semaphore new! !


!LindaTalkProcess class methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 11:54'!
terminateAll
	"Terminates all LindaTalkProcess"
	self allInstancesDo: [:ltp | ltp suspend ]! !


!ProcessorScheduler methodsFor: 'private' stamp: 'bolot 8/3/1999 11:53'!
anyProcessesAbove: highestPriority 
	"Do any instances of Process exist with higher priorities?"

	^(Process "allInstances" allSubInstances select: [:aProcess | 
		aProcess priority > highestPriority]) isEmpty
		"If anyone ever makes a subclass of Process, be sure to use allSubInstances."! !


!Subspace commentStamp: '<historical>' prior: 0!
This class and related classes in this category were originally written by Marcio Quintaes Marchini <mqm@magma.ca>, then at EDUGRAF, as part of his LindaTalk system.  See LindaTalk, Proceedings of the Supercomputing Symposium '94, June 1994, pp. 339-348.
We gratefully acknowledge Marcio's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:37'!
addInBlocking: blocking
	"Add a new LindaTalkBlocking for the In primitive"

	tuplesIn add: blocking! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:04'!
addLiveTuple: tuple
	"Add the live tuple in the internal partition."
	tuplesEval addLast: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:05'!
addOutTuple: tuple
	"Add the tuple in the corresponding partition.
	Mix the order, so that there is no order relation in the tuple
	space"
	mixer
		ifTrue:  [ tuplesOut addLast: tuple ]
		ifFalse: [ tuplesOut addFirst: tuple ].
	mixer := mixer not.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:05'!
addRdBlocking: blocking
	"Add a new LindaTalkBlocking for the Rd primitive"

	tuplesRd add: blocking! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:02'!
copy
	"Returns a copy of the Subspace"
	| copy |

	self mutexBegin.
	copy := super copy zeroTuples.
	self  inBlockings do: [:bloc | copy addInBlocking: bloc copy ].
	self  tuplesOut do: [:t | copy addOutTuple: t copy ].
	self  rdBlockings do: [:bloc | copy addInBlocking: bloc copy].
	self  tuplasVivas do: [:t | copy addLiveTuple: t  copy].
	self mutexEnd.
	^ copy! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:02'!
eval: tuple
	"Eval implementation. Call the primitive in the Tuple class.
	That primitive evaluates the blocks in parallel, and then the tuple becomes
	an ordinary tuple, which is outed"

	self class fork: [self liveToOrdinary: ( self runLiveTuple: tuple  )]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:03'!
in: tuple
	"In implementation"

	^ self inWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 16:03'!
inBlockingThatMatches: tuple
	"Returns the index of the LindaTalkBlocking In
	that matches tuple"

	| i |
	i := 1.
	self inBlockings do:
	[ :bloc |
		(tuple matches: bloc tuple)
			ifTrue: [ ^ i ].
		i := i + 1].
	^ 0! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:04'!
inBlockings
	"Returns the collection of LindaTalkBlockings In"

	^ tuplesIn! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:39'!
inNotWaitingTuple: tuple
	"inp. I do not get blocked if tuple is not available"

	^ self inNotWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:41'!
inNotWaitingTupleNoSideEffect: tuple
	"INP  primitive"
	| match tupleOutThatMatched copy |

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: [self mutexEnd.
			^nil]
		ifFalse: ["Found one out tuple that matches"
			tupleOutThatMatched := self removeTupleOut: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:41'!
inWaitingTuple: tuple
	"In implementation. I will be blocked if there is no tuple."
	^ self inWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:42'!
inWaitingTupleNoSideEffect: tuple
	"IN primitive"
	| match tupleOutThatMatched copy blocking|

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: ["No tuple matches. Add a blocking in the in partition "
			blocking :=  LindaTalkBlocking forTuple: copy.
			self addInBlocking: blocking;
				mutexEnd.
			blocking sleepProcess.
			"Out . Someone woke me up ."]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self removeTupleOut: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:13'!
initialize
	"Initialize the instance variables.
	A semaphore for mutual exclusion and the 3
	`partitions:  In, Out, Rd."

	mutex := Semaphore new.
	mutex signal.
	self zeroTuples.
	mixer := true. "Mix tuples"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:44'!
inp: tuple
	"Inp implementation"

	^ self inNotWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:44'!
isEmpty
	"Informs if the subspace is empty. That is, no partition has tuples."

	^ (self inBlockings isEmpty) and: [ (self rdBlockings isEmpty) and: [self tuplesOut isEmpty] ]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:44'!
justEval: tuple
	"Just like eval, but the resulting ordinary tuple is discarded
	after evaluation"

	self class fork: [  self runLiveTuple: tuple ]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:45'!
liveToOrdinary: tuple
	"Transforms a live tuple in ordinary"

	self out: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:47'!
mutexBegin
	"Begin of mutual exclusion"

	mutex wait! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:47'!
mutexEnd
	"End of mutual exclusion"

	mutex signal! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:47'!
nthBlockingIn: position
	"Returns the in blocking in the given position"

	^ tuplesIn at: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:48'!
nthBlockingRd: position
	"Returns the rd blocking in the given position"

	^ tuplesRd at: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:48'!
out: tuple
	"Out implementation"

	^ self outPersistentTuple: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:48'!
outNonPersistentTuple: tuple
	"OUTI primitive. If there is any blocked rd or in,
	there will be match. The tuple, however, never
	stays in the space"

	self outNonPersistentTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:49'!
outNonPersistentTupleNoSideEffect: tuple
	"OUTI implementation"
	| match tupleInThatMatched blocking |

	self mutexBegin.
	self wakeUpRdTuplesThatMatch: tuple. "Atention here"
	match := self inBlockingThatMatches: tuple.
	(match = 0 )
		ifFalse: ["Found one that matches. Remove from in partition"
			blocking := self removeInBlocking: match.
			tupleInThatMatched := blocking tupla.
			tuple transferContentsTo: tupleInThatMatched.
			blocking wakeUpProcess].
	self mutexEnd! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:49'!
outPersistentTuple: tuple
	"Out implementation. If there is any rd or in, there
	will be match"

	self outPersistentTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:50'!
outPersistentTupleNoSideEffect: tuple
	"OUT primitive"
	| match tupleInThatMatched blocking|

	self mutexBegin.
	self wakeUpRdTuplesThatMatch: tuple. "Atention here "
	match := self inBlockingThatMatches: tuple.
	(match = 0 )
		ifTrue: ["No tuple matches. Add in the set of out tuples."
			self addOutTuple: tuple;
				wakeUpRdTuplesThatMatch: tuple]
		ifFalse: ["Found one that matches. Remove from the in partition"
			blocking := self removeInBlocking: match.
			tupleInThatMatched := blocking tuple.
			tuple transferContentsTo: tupleInThatMatched.
			blocking wakeUpProcess].
	self mutexEnd! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:50'!
outi: tuple
	"Outi  implementation"

	^ self outNonPersistentTuple: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:50'!
rd: tuple
	"Rd  implementation"

	^ self rdWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:51'!
rdBlockings
	"Returns the collection of LindaTalkBlockings Rd"

	^ tuplesRd! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:10'!
rdNotWaitingTuple: tuple
	"Rdp primitive. I will not  be blocked if there is no tuple available."

	^ self rdNotWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:13'!
rdNotWaitingTupleNoSideEffect: tuple
	"Rdp implementation"

	| match tupleOutThatMatched copy|

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: [ self mutexEnd.
			^nil]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self tupleOutInPosition: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:12'!
rdWaitingTuple: tuple
	"Rd implementation. I will be blocked if there is no tuple available"

	^ self rdWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:14'!
rdWaitingTupleNoSideEffect: tuple
	"RD primitive"
	| match tupleOutThatMatched copy  blocking |

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: ["No tuple matches. Add in the rd partition"
			blocking :=  LindaTalkBlocking forTuple: copy.
			self addRdBlocking: blocking;
				mutexEnd.
			blocking sleepProcess.
			"Out. Someone woke me up."]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self tupleOutInPosition: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:14'!
rdp: tuple
	"Rdp  implementation"

	^ self rdNotWaitingTuple: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:14'!
removeInBlocking: position
	"Removes the blocking"

	| bloc |
	bloc := self nthBlockingIn: position.
	self removeTuple: position fromPartition: tuplesIn.
	^ bloc! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:15'!
removeLiveTuple: tuple
	"Removes a given live tuple from its partition"

	tuplesEval remove: tuple ifAbsent: [self error: 'Error in #removeLiveTuple:']! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:15'!
removeRdBlocking: position
	"Removes a rd blocking from the given position"

	| bloc|
	bloc := self nthBlockingRd: position.
	self removeTuple: position fromPartition: tuplesRd.
	^ bloc! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:15'!
removeTuple: position fromPartition: partition
	"Removes a given tuple from a given partition"

	partition removeAt: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:14'!
removeTupleOut: position
	"Removes a given out tuple from its partition"

	| t |
	t := self  tupleOutInPosition: position.
	self removeTuple: position fromPartition: tuplesOut.
	^ t! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:14'!
runLiveTuple: tuple
	"Live tuple creation kernel"

	| tupleEval |

	self mutexBegin;
		addLiveTuple: tuple;
		mutexEnd.

	tupleEval := tuple copy primEval;
		yourself.

	self mutexBegin;
		removeLiveTuple: tuple;
		mutexEnd.

	^ tupleEval! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/7/2000 10:25'!
scan: tuple
	"Scan  implementation"

	^ self scanNotWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/7/2000 11:03'!
scanNotWaitingTuple: tuple
	"Scan primitive. I will not  be blocked if there is no tuple available."

	^ self scanNotWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:14'!
scanNotWaitingTupleNoSideEffect: tuple
	"Scan implementation"

	| matches  copy |

	copy := tuple copy.
	self mutexBegin.
	matches := self tuplesOutThatMatches: copy.
	self mutexEnd.
	^ matches
! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:17'!
tuplasVivas
	"Returns the eval partition"

	^ tuplesEval! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:17'!
tupleOutInPosition: position
	"Returns the out tuple in the given position"

	^ tuplesOut at: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:14'!
tupleOutThatMatches: tuple
	"Returns the position of the out
	tuple that matches tuple"

	| i |
	i := 1.
	self tuplesOut do: [ :t |     "The matching is FROM tuple space TO my tuple"
		(t matches: tuple )
			ifTrue: [ ^ i ].
				i := i + 1].
	^ 0! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:18'!
tuplesOut
	"Returns the out partition"

	^ tuplesOut! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 16:03'!
tuplesOutThatMatches: tuple
	"Returns the collection of positions of the out
	tuples that matches tuple"

	^self tuplesOut select: [ :t |     "The matching is FROM tuple space TO my tuple"
		t matches: tuple ].
! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:14'!
wakeUpRdTuplesThatMatch: tuple
	"An out happened. Wake up processed that issued rd."

	| i size nthTuple nthBlocking |

	i := 1.
	size := self rdBlockings size.
	[ i > size ]
	whileFalse: [
		nthBlocking := self nthBlockingRd: i.
		nthTuple :=  nthBlocking tuple.
		(tuple matches: nthTuple)
			ifTrue: [
				nthBlocking := self removeRdBlocking: i.
				" nthBlocking := self retiraBloqueamentoRd: i. "
				nthTuple :=  nthBlocking tuple.
				tuple transferContentsTo: nthTuple.
				nthBlocking wakeUpProcess.
				size := size - 1]
			ifFalse: [i := i + 1]]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 2/19/2000 08:15'!
zeroTuples
	"Empties all partitions"

	tuplesIn := OrderedCollection new.
	tuplesRd := OrderedCollection new.
	tuplesOut := OrderedCollection new.
	tuplesEval := OrderedCollection new.! !


!Subspace class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:36'!
evalDefaultPriority
	"Returns the default process priority"

	^ Processor  userBackgroundPriority! !

!Subspace class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:37'!
fork: aBlock
	"Creates the eval processes"

	^ aBlock forkLindaTalkAt: self evalDefaultPriority! !

!Subspace class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:37'!
new
	"Creates and returns a new subspace"

	^ super new initialize! !


!Tuple commentStamp: '<historical>' prior: 0!
Tuple

A tuple is an ordered collection of objects.
For example:
Tuple:( 'marcio' | 'mqm@magma.ca' | 1999 | $q ).
"a tuple with real parameters"
Tuple:( String | String | Integer | Symbol ).
"a tuple with formal parameters"

Formal parameters are expressed using classes.
#isKindOf: is used to determine a match.

Tuples in LindaTalk are created from a list of objects, separated by $|.
For example: ('marcio' | 'mqm@magma.ca' | 1999 | $q).
Tuples may be assigned to variables or be part of another tuple:

	| tupleA tupleB |
	tupleA _ ('maria' | 45.7 | $r).
	tupleB _ (76 | tupleA | 'peter').

This class and related classes in this category were originally written by Marcio Quintaes Marchini <mqm@magma.ca>, then at EDUGRAF, as part of his LindaTalk system.  See LindaTalk, Proceedings of the Supercomputing Symposium '94, June 1994, pp. 339-348.
We gratefully acknowledge Marcio's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!Tuple methodsFor: 'initialize-release' stamp: 'rww 2/18/2000 21:40'!
initialize
	fields := OrderedCollection new.
	self class defaultArity timesRepeat: [self add: nil].! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 21:31'!
add: aTupleParameter
	"Adds another parameter to the original tuple"

	fields add: ((aTupleParameter isKindOf: TupleField)
		ifTrue: [aTupleParameter]
		ifFalse: [TupleField new value: aTupleParameter; yourself])! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 23:25'!
add: aTupleParameter withName: aName
	"Adds another parameter to the original tuple"

	fields add: ((aTupleParameter isKindOf: TupleField)
		ifTrue: [aTupleParameter]
		ifFalse: [TupleField new value: aTupleParameter; name: aName; yourself])! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 15:26'!
addAll: aParameterCollection
	"Add a collection of parameters to the original tuple"

	aParameterCollection do: [:e | self add: e].
! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 21:27'!
at: index
	"Get the parameter at the index"

	^self valueAt: index! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 21:31'!
at: index put: aTupleParameter
	"Put the parameter at the index"

	fields at: index put: ((aTupleParameter isKindOf: TupleField)
		ifTrue: [aTupleParameter]
		ifFalse: [TupleField new value: aTupleParameter; yourself])! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 23:25'!
at: index put: aTupleParameter withName: aName
	"Put the parameter at the index"

	fields at: index put: ((aTupleParameter isKindOf: TupleField)
		ifTrue: [aTupleParameter]
		ifFalse: [TupleField new value: aTupleParameter; name: aName; yourself])! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 23:26'!
atName: aName
	"Get the parameter at the index"

	^fields detect: [:e | e name = aName] ifNone: [nil]! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 21:34'!
do: aBlock
	self fieldsDo: [:eachField | aBlock value: eachField value].! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 21:26'!
fieldAt: index
	"Adds another parameter to the original tuple"

	^fields at: index! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 21:34'!
fieldsDo: aBlock
	fields do: [:eachField | aBlock value: eachField].! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 15:28'!
nameAt: index
	"Adds another parameter to the original tuple"

	^(self fieldAt: index) name! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 13:42'!
size
	^fields size! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 15:28'!
typeAt: index
	"Adds another parameter to the original tuple"

	^(self fieldAt: index) type! !

!Tuple methodsFor: 'collection API' stamp: 'rww 2/18/2000 15:28'!
valueAt: index
	"Adds another parameter to the original tuple"

	^(self fieldAt: index) value! !

!Tuple methodsFor: 'Linda API' stamp: 'rww 2/18/2000 13:50'!
eval: contextTupleSpace 
	"eval in the given tuple space"

	^contextTupleSpace eval: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/2/1999 23:28'!
in: aTupleSpace 
	"In at the given tuple space"

	^ aTupleSpace in: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/2/1999 23:29'!
inp: aTupleSpace 
	"inp in the given tuple space"

	^ aTupleSpace inp: self! !

!Tuple methodsFor: 'Linda API' stamp: 'rww 3/1/2000 06:29'!
matches: anotherTuple
	"Returns true if there is matching"
	"#RWW Note: currently order of the fields is important"

	( self arity = anotherTuple arity )
		ifFalse: [ ^ false ]. 

	( anotherTuple class withAllSubclasses includes: self class)
		ifFalse: [ ^ false ].

	1 to: self arity do: [ :i  | 
		((self fieldAt: i) matchesField: (anotherTuple fieldAt: i))
			ifFalse: [ ^ false ]]. 
	^ true! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/3/1999 00:03'!
out: aTupleSpace
	"out in the given tuple space"

	^ aTupleSpace out: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/3/1999 00:03'!
outi: aTupleSpace
	"outi in the given tuple space"

	^aTupleSpace outi: self! !

!Tuple methodsFor: 'Linda API' stamp: 'rww 2/19/2000 08:06'!
primEval
	"The actual eval.
	Forks the blocks in parallel, and replaces the
	parameters after the computations finish"

	| processes sync index|

	processes := Dictionary new.
	sync := Semaphore new.
	index := 1.
	self do: [:p |
		(p isEvaluation )
			ifTrue: [ processes at: index put: p].
		index := index + 1].
	"I have index->process"

	processes associationsDo: [:assoc |
		self fork: assoc value
			parameter: assoc key
			synchronizingIn: sync].

	processes keysDo: [:k | sync wait ]. "Wait all finish"
        ! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/3/1999 00:07'!
rd: aTupleSpace 
	"rd in the given tuple space"

	^ aTupleSpace rd: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/3/1999 00:08'!
rdp: aTupleSpace 
	"rdp in the given tuple space"

	^ aTupleSpace rdp: self! !

!Tuple methodsFor: 'field ops' stamp: 'bolot 8/2/1999 23:24'!
@ anIndex
	"Returns the given parameter"

	^ self at: anIndex! !

!Tuple methodsFor: 'field ops' stamp: 'bolot 8/2/1999 23:24'!
addParameter: aTupleParameter
	"Adds another parameter to the original tuple"

	self add: aTupleParameter! !

!Tuple methodsFor: 'field ops' stamp: 'bolot 8/2/1999 23:25'!
changeParameter: anIndex by: anObject
	"Changes a given parameter"

	self at: anIndex put: anObject! !

!Tuple methodsFor: 'field ops' stamp: 'bolot 8/3/1999 00:04'!
parameter: anIndex
	"Returns the given tuple parameter (indexed)"

	^ self at: anIndex! !

!Tuple methodsFor: 'field ops' stamp: 'rww 2/18/2000 13:56'!
| anElement 
	"Adds another parameter to the original tuple"

	^ self add: anElement; yourself! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:24'!
- anIndex
	"Returns a new tuple, which is just like
	the original one, but without the element
	anIndex"

	^ self  copy removeAtIndex: anIndex; yourself! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:25'!
arity
	"Returns the number of elements of the tuple"

	^ self size! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:25'!
asTuple 
	"Returns myself"

	^ self! !

!Tuple methodsFor: 'utils' stamp: 'rww 2/18/2000 15:53'!
fork: anEvaluatableField parameter: anIndex  synchronizingIn: semaphore
	"Forks a process for the corresponding live parameter.
	When finished, the process signals a semaphore,
	so that the root process which forked the live
	parameters can collect the results and assemble
	the resulting ordinary tuple."

	self class fork:
		[self changeParameter: anIndex by: anEvaluatableField evaluate.
		semaphore signal]! !

!Tuple methodsFor: 'utils' stamp: 'rww 2/13/2000 11:42'!
isTuple

	^true! !

!Tuple methodsFor: 'utils' stamp: 'rww 2/18/2000 21:33'!
printOn: aStream
	"Shows the tuple"

	aStream nextPutAll: self class name , ':(  '.
	self fieldsDo: [:eachField |
		eachField isEvaluation
			ifTrue: [ aStream nextPutAll: '[...computing...]' ]
			ifFalse: [
				eachField isFilter
					ifTrue: [ aStream nextPutAll: ' Filter [:x | ...filter x...]' ]
					ifFalse: [ eachField value printOn: aStream]].
		aStream nextPutAll: ' | '].
	aStream skip: -2.
	aStream nextPutAll: ') '! !

!Tuple methodsFor: 'utils' stamp: 'rww 3/1/2000 08:14'!
transferContentsTo: anotherTuple
	"Implements the transfer from reals to potentials"

	| index |
	index := 1.
	anotherTuple  fieldsDo: [ :p |
		(p isPotential or: [p isFilter])
			ifTrue: [ anotherTuple changeParameter: index
					by: (self parameter: index )].
		index := index + 1]! !


!Tuple class methodsFor: 'instance creation' stamp: 'rww 2/18/2000 21:39'!
defaultArity
	^0! !

!Tuple class methodsFor: 'instance creation' stamp: 'rww 2/18/2000 16:01'!
example
	"Example of tuple matching" 

	^ ( 5 | nil | $f | Point ) 
		matches: 
			( Integer | UndefinedObject | $f | (2@3) )! !

!Tuple class methodsFor: 'instance creation' stamp: 'bolot 8/2/1999 23:23'!
fork: aBlock
	"Creates an eval process"

	^ Subspace fork: aBlock! !

!Tuple class methodsFor: 'instance creation' stamp: 'rww 2/18/2000 13:33'!
new
	^super new initialize! !


!TupleField methodsFor: 'accessing' stamp: 'rww 2/18/2000 13:18'!
name
	"Answer the receiver's instance variable name."

	^name! !

!TupleField methodsFor: 'accessing' stamp: 'rww 2/18/2000 13:18'!
name: anObject
	"Set the receiver's instance variable name to anObject."

	name := anObject! !

!TupleField methodsFor: 'accessing' stamp: 'rww 2/18/2000 13:18'!
type
	"Answer the receiver's instance variable type."

	^type! !

!TupleField methodsFor: 'accessing' stamp: 'rww 2/18/2000 13:18'!
type: anObject
	"Set the receiver's instance variable type to anObject."

	type := anObject! !

!TupleField methodsFor: 'accessing' stamp: 'rww 2/18/2000 13:18'!
value
	"Answer the receiver's instance variable value."

	^value! !

!TupleField methodsFor: 'accessing' stamp: 'rww 2/18/2000 22:55'!
value: anObject
	"Set the receiver's instance variable value to anObject."

	value := anObject.
	self type: anObject class.! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 17:41'!
evaluationClass
	"Returns the class that represents
	a LindaTalk Evaluation. That is, the elements
	in a live tuple"

	^ BlockContext! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 17:41'!
filterClass
	"Returns the class that represents filters in LindaTalk"

	^ BlockContext! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 17:41'!
isEvaluation
	^(self value isKindOf: self evaluationClass) 
		and: [0 = self value numArgs]! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 17:40'!
isFilter
	^(self value isKindOf: self filterClass)
		and: [1 = self value numArgs]! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 15:23'!
isPotential
	^self value isKindOf: Behavior! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 23:49'!
matchesField: aField
	"field matching is somewhat involved.  
		-The values could match
		"

	(self value = aField value)
		ifTrue: [ ^ true ]. 
 
	self isPotential
		ifTrue: [^aField matchesPotentialField: self]
		ifFalse: [aField isPotential
			ifTrue: [^self matchesPotentialField: aField]
			ifFalse: [aField isFilter
				ifTrue: [^self matchesFilterField: aField]
				ifFalse: [^false]]].
! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 19:29'!
matchesFilterField: aField

	self isFilter
		ifTrue: [^false].
	^aField value value: self value.
! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 20:59'!
matchesPotentialField: aField

	self isPotential
		ifTrue: [^self value == aField value].
	^self value isKindOf: aField value! !

!TupleField methodsFor: 'testing' stamp: 'rww 2/18/2000 23:10'!
printOn: aStream
	"Shows the TupleField"

	aStream nextPutAll: self class name , ':(  '.
	self isEvaluation
		ifTrue: [ aStream nextPutAll: '[...computing...]' ]
		ifFalse: [
			self name ifNotNil: [aStream nextPutAll: 'name: ', self name printString, ', '].
			aStream nextPutAll: 'type: ', self type name asString, ', '.
			self isFilter
				ifTrue: [ aStream nextPutAll: ' Filter [:x | ...filter x...]' ]
				ifFalse: [ aStream nextPutAll: 'value: '.
					self value printOn: aStream.]].
	aStream nextPutAll: ') '! !


!TupleField class methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 13:22'!
name: aName
	^self type: 'NAME' value: nil name: aName.
! !

!TupleField class methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 13:21'!
type: aType
	^self type: aType value: nil.
! !

!TupleField class methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 13:21'!
type: aType value: aValue
	^self type: aType value: aValue name: ''.
! !

!TupleField class methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 13:20'!
type: aType value: aValue name: aName
	|field|
	field := self new.
	field value: aValue.
	field type: aType.
	field name: aName.
	^field! !

!TupleField class methodsFor: 'as yet unclassified' stamp: 'rww 2/18/2000 13:20'!
value: aValue
	^self type: aValue class value: aValue! !


!TupleSpace commentStamp: '<historical>' prior: 0!
""
Extend query capabilities to include logic comparisons (nested), sparse matching and series and functional matching.

Linda Theory       TSpaces::TupleSpace        Collection Protocol
  out                   write(<tuple>)               #add: aTuple
  in                   take(<template>)            #removeWithTemplate: aTupleTemplate
  rd                read(<template>)             #detectWithTemplate: aTupleTemplate
  scan                scan(<template>)            #selectWithTemplate: aTupleTemplate
  N/A                    N/A                        #collect: aGeneratorBlock
  eval                    N/A                        #do: aRemoteEvaluationBlock
  N/A            registerEvent(<event>)           #when: event do: notification
  N/A            registerEvent(<event>)          #when: event callback: client
  eval                    N/A                    #evaluate: aRemoteEvaluationBlock
  N/A                    N/A                            #snapshot
  N/A                    N/A                                #copy
  N/A                    N/A                             #disconnect
  N/A                    N/A                     #reconnectWithSecurity: userToken
  N/A                    N/A                    class>>#connect: spaceName withSecurity: userToken
  N/A                    N/A                    class>>#create: spaceName withSecurity: userToken attributes spaceSpec


*Security (Users and Tokens, Sandbox)
*Monitor and dispather for half sync/half async
*Events
*Exceptions
*Transactions and pending
*Persistence
*File system
*Admin
*Remote Execution
*Mobile Metaclasses
*Configurable protocol

!

!TupleSpace methodsFor: 'initialize-release' stamp: 'rww 3/6/2000 12:39'!
initialize
	subspaces := Dictionary new.

! !

!TupleSpace methodsFor: 'errors' stamp: 'rww 3/6/2000 11:33'!
errorNotKeyed
	self lindaError new messageText: 'TupleSpace is not keyed'; signal.
! !

!TupleSpace methodsFor: 'errors' stamp: 'rww 3/6/2000 11:29'!
lindaError

	^self class lindaError.
! !

!TupleSpace methodsFor: 'errors' stamp: 'rww 3/6/2000 11:30'!
tupleNotFound
	self lindaError new messageText: 'Tuple not found'; signal.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:39'!
eval: tuple
	"Forwards the eval primitive to the right partition"
	^( self sub: tuple ) eval: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:40'!
in: tuple
	"Forwards the in primitive to the right partition"
	^( self sub: tuple ) in: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:40'!
inp: tuple
	"Forwards the inp primitive to the right partition"
	^( self sub: tuple ) inp: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:40'!
justEval: tuple
	"Forwards the justEval primitive to the right partition"
	^( self sub: tuple ) justEval: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:42'!
out: tuple
	"Forwards the out primitive to the right partition"

	^( self sub: tuple ) out: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:42'!
outi: tuple
	"Forwards the outi primitive to the right partition"

	^( self sub: tuple ) outi: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:42'!
rd: tuple
	"Forwards the rd primitive to the right partition"
	^( self sub: tuple ) rd: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:43'!
rdp: tuple
	"Forwards the rdp primitive to the right partition"
	^( self sub: tuple ) rdp: tuple.
! !

!TupleSpace methodsFor: 'API' stamp: 'rww 3/6/2000 11:43'!
scan: tuple
	"Forwards the in primitive to the right partition"
	^( self sub: tuple ) scan: tuple.
! !

!TupleSpace methodsFor: 'tools' stamp: 'rww 3/6/2000 12:43'!
compact
	"Deletes empty partitions"

	(self subspaces select: [:x | x isEmpty] ) keysDo: [:size | self subspaces removeKey: size]! !

!TupleSpace methodsFor: 'tools' stamp: 'rww 3/6/2000 11:19'!
copy
	"Returns a copy of the TupleSpace"
	| copy dic |

	copy := super copy.
	dic := Dictionary new.
	self subspaces associationsDo: [ :assoc | 
		dic at: assoc key put: assoc value copy ].
	copy subspaces: dic.
	^ copy! !

!TupleSpace methodsFor: 'tools' stamp: 'rww 3/6/2000 12:42'!
flush
	"Flushes (emties) the TupleSpace"

	subspaces := Dictionary new.
	self unsubscribe.
! !

!TupleSpace methodsFor: 'tools' stamp: 'rww 3/6/2000 12:43'!
partitions
	"Returns a collection of partitions with tuples
	(e.g.  #(1 5 8 9) )."  

	^ subspaces keys asSortedCollection! !

!TupleSpace methodsFor: 'tools' stamp: 'rww 3/6/2000 12:43'!
sub: tuple
	"Returns the subspace for the tuple.
	This is like hashing a big TuplaSpace in
	subspaces based on tuple sizes."

	^ self subspaceForArity: tuple arity! !

!TupleSpace methodsFor: 'tools' stamp: 'rww 3/6/2000 12:44'!
subspaceForArity: tupleArity
	"Returns the subspace where the tuples of a given
	size are stored, etc."

	| newSub |

	^ subspaces
		at: tupleArity
		ifAbsent:
			[subspaces
				at: tupleArity
				put: ( newSub := Subspace new).
			^ newSub ]! !

!TupleSpace methodsFor: 'tools' stamp: 'rww 3/6/2000 12:44'!
subspaces
	"Answer the receiver's instance variable subspaces."

	^subspaces! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:31'!
add: aTuple
	^self out: aTuple
! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:33'!
at: index
	self errorNotKeyed! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:33'!
at: index put: anObject
	self errorNotKeyed! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:34'!
collect: aTupleTemplate 
	self notYetImplemented.
! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:36'!
detect: aTupleTemplate
	^self detect: aTupleTemplate ifNone: [self tupleNotFound].

! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:34'!
detect: aTupleTemplate ifNone: aNoneBlock
	|result|
	result := self rdp: aTupleTemplate.
	^ result ifNil: [aNoneBlock value].
! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:34'!
do: anEvalTuple 
	self notYetImplemented.

! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:35'!
includes: aTupleTemplate
	^self subspaces includes: aTupleTemplate
! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:36'!
remove: aTupleTemplate
	^self remove: aTupleTemplate ifNone: [self tupleNotFound].
! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:36'!
remove: aTupleTemplate ifNone: aNoneBlock
	|result|
	result := self inp: aTupleTemplate.
	^result ifNil: [aNoneBlock value].
! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:36'!
removeAll: aTupleTemplate
	|all|
	all := self scan: aTupleTemplate.
	all do: [:e | self remove: e].
	^all! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 3/6/2000 11:36'!
select: aTupleTemplate 
	^self scan: aTupleTemplate.

! !


!TupleSpace class methodsFor: 'tests' stamp: 'rww 3/6/2000 12:52'!
example0
	" TupleSpace example0"

|tupleSpace|
tupleSpace := TupleSpace new.
tupleSpace out: ('Admin' | ((Dictionary new) at: 2 put: (WriteStream on: ''); yourself)).
tupleSpace out: ('Callisto' | 'ACL' | ((Array new: 2) at: 1 put: 'slosher'; at: 2 put: 'password'; yourself)).
tupleSpace out: ('WorkQueue' | 'worker2' | 20).
tupleSpace out: ('Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' | 
	'Admin' ).

	tupleSpace explore.! !

!TupleSpace class methodsFor: 'tests' stamp: 'rww 3/6/2000 11:24'!
testCallback
	" TupleSpace testCallback"

|ts printBlock|
printBlock := [:event :tupleColl | Transcript cr; 
	show: 'Event: ', 
			event printString, 
			' tupleColl: ', 
			tupleColl printString].
ts := TupleSpace new.
ts registerCallback: #value:value: forEvent: #out: to: printBlock.
ts out: ('test' | 'rob').
ts explore.
! !

!TupleSpace class methodsFor: 'error handling' stamp: 'rww 3/6/2000 11:23'!
lindaError
	^LindaError! !

!TupleSpace class methodsFor: 'error handling' stamp: 'rww 3/6/2000 12:36'!
new
	^super new initialize.
! !


